<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"template.lib.php", "network.lib.php"
	);
	
	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action|", "id|", "return|");

	switch ($action) {
		case "submit":

			// antiflood protection
			$AccessTable->load_rule (
				$AccessTable->set_generic_rule ("contact-submit-msg", "post"),
				"E_ANTI_FLOOD"
			);

			varImport("subject", "from", "email", "message");

			varRequire("subject", "from", "email", "message");

			if (preg_match("/\n|\r/s", $from) || preg_match("/\n|\r/s", $email) || preg_match("/\n|\r/s", $subject))
				abort("I don't like spam.");

			if (!preg_match("/[a-z0-9\.\-_]@[a-z0-9\.]/", $email))
				abort(_l("E_INVALID_MAIL_ADDR"));
		
			// sending mail
			sendmail(conf::getkey("core", "site.contact_mail"),
				_l("L_CONTACT_MESSAGE"),
				mkLetter (
					"contact/feedback",
					Array (
						"SUBJECT"		=> $subject,
						"SENDER"		=> $from,
						"SENDERMAIL"	=> $email,
						"SENDERIP"		=> getIP(),
						"MESSAGE"		=> $message
					)
				),
				"text/plain",
				"Reply-To: $email\r\n"
			);
		
			gcookie("name", $from);
			gcookie("email", $email);
			
			slog("contact: received message from $email", "actions", 1);

			$return = "../../index.php?message=".urlencode(_l("L_MESSAGE_SENT"));
		break;
	}

	if (is_admin()) {
		switch ($action) {
			case "send":
			
				varImport("to", "subject", "message");

				varRequire("to", "message");
	
				sendmail($to, $subject, $message, "text/plain");
	
				slog("contact: message sent to $to", "actions", 1);
	
				$return = urlEvalPrototype("index.php/module=admin", true, false);
				
			break;
		}
	}

	redirect($return);

	db_exit();
?>